#!/usr/bin/python2
from scipy import *
import scipy.sparse as sp
import scipy.linalg as la
#See http://scikit-learn.org/stable/modules/feature_extraction.html
import sklearn.feature_extraction as fe
import tok

#Read text, try removing comments, headers ... See tok.py for implementation.
corpus = tok.fill_corpus(["alt.atheism", "comp.windows.x"])

#Create training data
ctr = reduce(list.__add__, map(lambda x: x[:600], corpus))
ytr = zeros(len(ctr)); ytr[:600] = -1; ytr[600:] = 1

#Train a bag-of-words feature extractor.
#You're free to play with the parameters of fe.text.TfidfVectorizer, but your answers
#*should be* answered for the parameters given here. You can find out more about these
#on the scikits-learn documentation site.
tfidf = fe.text.TfidfVectorizer(min_df=5, ngram_range=(1, 4), use_idf=True, encoding="ascii")

#Train the tokenizer.
ftr = tfidf.fit_transform(ctr)
ftr = ftr.tocsc()

#This maps features back to their text.
feature_names = tfidf.get_feature_names()

m = 30
#This shouldn't take more than 20m.
#<Adaboost goes here>

#Create validation data
cva = reduce(list.__add__, map(lambda x: x[600:800], corpus))
yva = zeros(len(cva)); ytr[:200] = -1; ytr[200:] = 1

#tfidf tokenizer is not trained here.
fva = tfidf.transform(cva).tocsc()

#<Validation code goes here>


#Create test data
#Some lists have less than a thousand mails. You may have to change this.
cte = reduce(list.__add__, map(lambda x: x[800:], corpus))
yte = zeros(len(cte)); yte[:200] = -1; yte[200:] = 1

fte = tfidf.transform(cva).tocsc()

#<Testing code goes here>
